﻿Imports System
Imports Wisej.Web

Public Class Page1
    Dim dgcell As DataGridViewCell
    Private Sub Page1_Load(sender As Object, e As EventArgs) Handles Me.Load
        LoadData()

        txtSetScrollCol.Text = "0"
        txtSetScrollRow.Text = "0"
        txtSetCurrentCol.Text = "0"
        txtSetCurrentRow.Text = "0"

    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        LoadData()
    End Sub

    Private Sub LoadData()
        Dim DT As New List(Of TestRowData)

        DataGridView1.DataSource = Nothing

        For a As Integer = 1 To 100

            DT.Add(New TestRowData With {.Name = "User" & CStr(Int((1024 * Rnd()) + 1)), .LastName = "User " & CStr(Int((1024 * Rnd()) + 1)), .Age = Int((50 * Rnd()) + 18)})

        Next

        DataGridView1.DataSource = DT
    End Sub

    Private Sub DataGridView1_Sorted(sender As Object, e As EventArgs) Handles DataGridView1.Sorted

        'MessageBox.Show("You broke it (?)")

        'If DataGridView1.VerticalScroll IsNot Nothing Then
        '    DataGridView1.VerticalScroll.Value = 0
        'End If

        Dim auxDG As DataGridView
        auxDG = CType(sender, DataGridView)

        If rbScrollCell.Checked Then
            'Move the displayed zone of the DataGrid
            DataGridView1.ScrollCellIntoView(CType(txtSetScrollCol.Text, Integer),
                                            CType(txtSetScrollRow.Text, Integer))

        End If

        If rbCurrentCell.Checked Then
            'Set the selected cell into de DataGrid
            DataGridView1.SetCurrentCell(CType(txtSetCurrentCol.Text, Integer),
                                         CType(txtSetCurrentRow.Text, Integer))
        End If


        'current selected cell
        txtCurrentColumn.Text = auxDG.CurrentCell.ColumnIndex.ToString
        txtCurrentRow.Text = auxDG.CurrentCell.RowIndex.ToString



    End Sub
    Private Sub DataGridView1_CellEnter(sender As Object, e As DataGridViewCellEventArgs) Handles DataGridView1.CellEnter

        txtCurrentRow.Text = DataGridView1.CurrentCell.RowIndex.ToString
        txtCurrentColumn.Text = DataGridView1.CurrentCell.ColumnIndex.ToString

    End Sub

    Private Sub DataGridView1_SelectionChanged(sender As Object, e As EventArgs)

    End Sub



    Private Sub btnScrollCellIntoView_Click(sender As Object, e As EventArgs) Handles btnScrollCellIntoView.Click
        If rbScrollCell.Checked Then

            If IsNumeric(txtSetScrollCol.Text) And IsNumeric(txtSetScrollRow.Text) Then

                'Move the displayed zone of the DataGrid
                DataGridView1.ScrollCellIntoView(CType(txtSetScrollCol.Text, Integer),
                                                 CType(txtSetScrollRow.Text, Integer))

                CurrentCell()
            End If

        End If

    End Sub

    Private Sub btnGetCurrentCell_Click(sender As Object, e As EventArgs) Handles btnGetCurrentCell.Click
        dgcell = DataGridView1.CurrentCell

        lblGetCurrentCell.Text = "Getted cell (col,row) :" & dgcell.ColumnIndex.ToString & ", " & dgcell.RowIndex.ToString
    End Sub

    Private Sub btnSetGettedCell_Click(sender As Object, e As EventArgs) Handles btnSetGettedCell.Click
        DataGridView1.ScrollCellIntoView(dgcell)

        CurrentCell()
    End Sub

    Private Sub btnSetCurrentCell_Click(sender As Object, e As EventArgs) Handles btnSetCurrentCell.Click

        If rbCurrentCell.Checked Then
            'Set the selected cell into de DataGrid
            If IsNumeric(txtSetCurrentCol.Text) And IsNumeric(txtSetCurrentRow.Text) Then

                DataGridView1.SetCurrentCell(CType(txtSetCurrentCol.Text, Integer),
                                        CType(txtSetCurrentRow.Text, Integer))

                CurrentCell()
            End If


        End If


    End Sub
    Private Sub CurrentCell()
        'current selected cell
        txtCurrentColumn.Text = DataGridView1.CurrentCell.ColumnIndex.ToString
        txtCurrentRow.Text = DataGridView1.CurrentCell.RowIndex.ToString
    End Sub

    Private Class TestRowData
        Public Property Name As String = ""
        Public Property LastName As String = ""
        Public Property Age As Integer = 32
    End Class


End Class
